open## @file SequenceAO.py
#  @author Spencer Smith
#  @brief Implements an abstract object for a sequence, as specified
#  in L9, program written in Python 2.7
#  @date 1/24/2017

## @brief An Abstract Object that represents a sequence
class Seq:
    
  MAX_SIZE = 100
  
  s = []

  @staticmethod
  def init():
    Seq.s = []

  @staticmethod
  def add(i, p):
    s = Seq.s
    size = len(s)
    if size == Seq.MAX_SIZE:
      raise Full("Maximum size exceeded")
    if (i not in range(0, size+1)):
      raise Pos(i)
    s = s[0:i] + [p] + s[i:size]
    Seq.s = s
    
  @staticmethod
  def delt(i):
    s = Seq.s
    size = len(s)
    if (i not in range(0, size)):
      raise Pos(i)
    s = s[0:i] + s[i+1:size]
    Seq.s = s
    
  @staticmethod
  def setval(i, p):
    size = len(Seq.s)
    if (i not in range(0, size)):
      raise Pos(i)
    Seq.s[i] = p
    
  @staticmethod
  def getval(i):
    size = len(Seq.s)   
    if (i not in range(0, size)):
      raise Pos(i)   
    return Seq.s[i]
    
  @staticmethod
  def size():
    return len(Seq.s)

class Full(Exception):
  def __init__(self, value):
    self.value = value
  def __str__(self):
    return str(self.value)

class Pos(Exception):
  def __init__(self, ivalue):
    self.ivalue = ivalue
  def __str__(self):
    return str(self.ivalue)
