import org.junit.*;
import static org.junit.Assert.*;
public class TestPointT
{
   private static double ADMISS_ERR_CONSTRUCTOR = 0;
   private static double ADMISS_ERR_DIST = 1e-20;
   @Test
   public void testConstructorForx()
   {
     assertEquals(23, new PointT(23, 38).xcoord(), ADMISS_ERR_CONSTRUCTOR);
   }
   @Test
   public void testConstructorFory()
   {
     assertEquals(38, new PointT(23, 38).ycoord(), ADMISS_ERR_CONSTRUCTOR);
   }
   @Test (expected=InvalidPointException.class)
   public void testForExceptionNegx()
   {
     PointT p = new PointT(-10, 0);
   }
   @Test (expected=InvalidPointException.class)
   public void testForExceptionNegy()
   {
     PointT p = new PointT(0, -10);
   }
   @Test (expected=InvalidPointException.class)
   public void testForExceptionMaxx()
   {
     PointT p = new PointT(Constants.MAX_X+1, 0);
   }
   @Test (expected=InvalidPointException.class)
   public void testForExceptionMaxy()
   {
     PointT p = new PointT(0, Constants.MAX_Y+1);
   }
   @Test
   public void testDistNormal()
   {
     double x = Constants.MAX_X/2.0;
     double y = Constants.MAX_Y/2.0;
     PointT p = new PointT(x, y);
     assertEquals(Math.sqrt(x*x + y*y), p.dist(new PointT(0, 0)), ADMISS_ERR_DIST);
   }
   @Test
   public void testDistLargestDiagonal()
   {
     double x = Constants.MAX_X;
     double y = Constants.MAX_Y;
     PointT p = new PointT(x, y);
     assertEquals(Math.sqrt(x*x + y*y), p.dist(new PointT(0, 0)), ADMISS_ERR_DIST);
   }
   @Test
   public void testDistAlongEdge()
   {
     double x = Constants.MAX_X;
     double y = Constants.MAX_Y;
     PointT p = new PointT(x, y);
     assertEquals(Constants.MAX_X, p.dist(new PointT(0, Constants.MAX_Y)), ADMISS_ERR_DIST);
   }
   @Test
   public void testDistZero()
   {
     double x = Constants.MAX_X/2.0;
     double y = Constants.MAX_Y/2.0;     
     PointT p = new PointT(x, y);
     assertEquals(0, p.dist(p), ADMISS_ERR_DIST);
   }
    //etc.
}
